
m_ifunc_capturezone <- Entities.FindByClassname(null,"trigger_look")
m_flCaptureZoneThinkTime <- 0.05
bombmodel <- null
bot_deploy_model <- null;

/*
function Precache()
{
	self.PrecacheScriptSound("MVM.DeployBombSmall");
	self.PrecacheScriptSound("MVM.DeployBombGiant");
}
*/

BombDeployPostSpawn <- function()
{
	EntFireByHandle(m_ifunc_capturezone, "Disable", "", 0.1, null, null); // disable the capturezone we should only enable once the animation is complete
	CaptureZoneThink() //make a fake think so we don't override the main one!
}

local DeployTimeSmall = DEPLOYTIME_GENERIC
local AllowDeploy = true;
local AllowBoom = true;
local cosmeticArray = [];
function CaptureZoneThink()
{
	local pPlayer = null
	local playerzonesizeadjuster = Entities.FindByClassnameWithin(null, "player", m_ifunc_capturezone.GetCenter(), 500.0) // find all players within a radious around the capturezone
	if(playerzonesizeadjuster != null)

	if(playerzonesizeadjuster.IsMiniBoss()){ pPlayer = Entities.FindByClassnameWithin(null, "player", m_ifunc_capturezone.GetCenter(), 128.0)}
	else {pPlayer = Entities.FindByClassnameWithin(null, "player", m_ifunc_capturezone.GetCenter(), 96.0)}

	if(pPlayer != null)
	{
		//pPlayer.AddCustomAttribute("generate rage on heal", 4, -1);
		if(pPlayer.GetTeam() == 3 && pPlayer.HasItem())
		{
			if((pPlayer.GetAbsVelocity().Length() <= 420.0) && !pPlayer.IsInvulnerable() && !pPlayer.IsImmuneToPushback())
			{
				pPlayer.CancelTaunt()
				pPlayer.EndLongTaunt()
				pPlayer.SetForcedTauntCam(1)
				pPlayer.SetDrawEnabled(false)
				PlayerDisable(pPlayer,true)
				for (local wearable = pPlayer.FirstMoveChild(); wearable != null; wearable = wearable.NextMovePeer())
				{
					if (wearable.GetClassname() != "tf_wearable")
						continue;

					cosmeticArray.push(wearable)
					wearable.SetDrawEnabled(false)
				}

				if(AllowDeploy)// since this a constant think it might trigger the deploy again, we only need one!
				{
					AllowDeploy = false
					BombDeploy(pPlayer)
				}

				if(bot_deploy_model == null)
					return

				if(bot_deploy_model.GetOwner() == pPlayer)
				{
					if(Time() > DeployTimeSmall)
					{
						if(AllowBoom)
						{
							AllowBoom = false
							Boom()
						}
					}
				}
			}
			else
			{
				printl("stopdeploy")
				AllowDeploy = true
				local cosmetic = null // Assign the "cosmetic" variable to null, will be assigned new values when going over cosmetic items
				while (cosmetic = Entities.FindByClassname(cosmetic, "tf_wearable")) // Goes over every cosmetic item, executing code below
				{
					if (cosmetic.GetOwner() == pPlayer) // Checks if the currently iterated cosmetic item's wearer is the !activator
					{
						cosmetic.SetDrawEnabled(true)
						//printl(cosmetic.GetModelName())
					}
				}
				pPlayer.SetDrawEnabled(true)
				local bomb = NetProps.GetPropEntity(pPlayer, "m_hItem")
				bomb.SetDrawEnabled(true)
				PlayerDisable(pPlayer,false)
				DeployTimeSmall = DEPLOYTIME_GENERIC
				pPlayer.SetForcedTauntCam(0)
				if(bot_deploy_model != null)
				{
					bot_deploy_model.Destroy()
					bot_deploy_model <- null;
					cosmeticArray = []
				}
			}
		}
	}

	EntFireByHandle(self, "RunScriptCode", "CaptureZoneThink()", m_flCaptureZoneThinkTime, null, null); // call self to make a fake think!
}
function MakePlayerCosmetics(ply,tf_wearable)
{
	local hWearable = Entities.CreateByClassname("prop_dynamic_ornament")
	hWearable.SetSkin(1)
	hWearable.SetAbsOrigin(Vector(0,0,-999));
	hWearable.SetModel(tf_wearable.GetModelName())
	NetProps.SetPropEntity(hWearable, "m_hOwnerEntity", bot_deploy_model);
	NetProps.SetPropString(hWearable, "m_initialOwner", "fakebombmodel");
	Entities.DispatchSpawn(hWearable);	//Spawns ent into world
	EntFireByHandle(hWearable, "setattached", "fakePlayermodel", 0.02, null, null);
}



function BombDeploy( pPlayer = null)
{
	if(pPlayer == null)
		return

	bot_deploy_model = CreateProp("prop_dynamic", pPlayer.GetOrigin(), "models/player/fracture/bot_"+GetPlayerClassString(pPlayer)+".mdl", 0)
	NetProps.SetPropString(bot_deploy_model, "m_iName", "fakePlayermodel");
	bombmodel = CreateProp("prop_dynamic", Vector(0,0,0), "models/props_td/atom_bomb.mdl", 0)
	NetProps.SetPropString(bombmodel, "m_iName", "fakebombmodel");
	bot_deploy_model.SetAbsAngles(VectorAngles(pPlayer.GetOrigin(),m_ifunc_capturezone.GetCenter()))
	EntFire("fakebombmodel", "SetParent", "fakePlayermodel", 0.1);
	EntFire("fakebombmodel", "SetParentAttachment", "flag", 0.2);
	local bomb = NetProps.GetPropEntity(pPlayer, "m_hItem")
	NetProps.SetPropInt(bomb, "m_nRenderMode", 10);

	PlayDeployAnim(bot_deploy_model)
	for (local i = 0; i < 7; i++)
	{
		bot_deploy_model.SetBodygroup(i,pPlayer.GetBodygroup(i))
	}
	foreach (fakehat in cosmeticArray)
	{
		MakePlayerCosmetics(pPlayer,fakehat)
	}
	bot_deploy_model.SetSkin(1)
	if(pPlayer.IsMiniBoss()){ bot_deploy_model.SetModelScale(1.75, 0.0); bot_deploy_model.EmitSound("MVM.DeployBombGiant"); }
	else{ bot_deploy_model.EmitSound("MVM.DeployBombSmall") }
	DeployTimeSmall = DeployTimeSmall + Time()
	bot_deploy_model.SetOwner(pPlayer)

}

function Boom()
{
	local cosmetic = null
	while (cosmetic = Entities.FindByClassname(cosmetic, "tf_wearable")) // Goes over every cosmetic item, executing code below
	{
		cosmetic.SetDrawEnabled(true)
	}
	EntFire("boss_deploy_relay", "trigger", "", 0.0); // call self to make a fake think!
	printl("boom!")
	bot_deploy_model.Destroy()
	bot_deploy_model <- null;
}