

//IncludeScript("sprinkles_util.nut")
m_flTankThinkTime <- 0.05

m_iDefinedHealth <- NetProps.GetPropString(self, "m_iszGroupMembers[0]").slice(7, NetProps.GetPropString(self, "m_iszGroupMembers[0]").len()).tointeger() //base health defined by map
m_iSpeed <- NetProps.GetPropString(self, "m_iszGroupMembers[1]").slice(6, NetProps.GetPropString(self, "m_iszGroupMembers[1]").len()) //base speed defined by map
m_sStartTrack <- NetProps.GetPropString(self, "m_iszGroupMembers[2]").slice(10, NetProps.GetPropString(self, "m_iszGroupMembers[2]").len())
m_sEndTrack <- NetProps.GetPropString(self, "m_iszGroupMembers[3]").slice(8, NetProps.GetPropString(self, "m_iszGroupMembers[3]").len())

::money_table <-
[
    ["item_currencypack_large"],
    ["item_currencypack_medium"],
    ["item_currencypack_small"],
    ["item_currencypack_custom"]
]

m_iHealth <- m_iDefinedHealth // redundent but it works

::TrackArray <- []
m_eStartTrack_Ent <- Entities.FindByName(null, m_sStartTrack)
m_eEndTrack_Ent <- Entities.FindByName(null, m_sEndTrack)

::CPArray <- []
m_eNextTrack <- null;
m_ePrevTrack <- null;
m_iTrackLength <- 0
m_eTank <- null;
m_eTankGlow <- null;
m_eTankDestory <- null;
m_bFirstTrackCheck <- false;
m_eFakeTankMain <- null;

CPArray.push(m_eStartTrack_Ent)

m_eTrainWatcher <- Entities.FindByClassname(null, "team_train_watcher")
m_eTrain <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszTrain"))
NetProps.SetPropFloat(m_eTrain, "m_maxSpeed", m_iSpeed.tofloat() + 1)
m_eLinkedCP1 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[0]"))
if (m_eLinkedCP1 != null) {CPArray.push(m_eLinkedCP1) }
m_eLinkedCP2 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[1]"))
if (m_eLinkedCP2 != null) {CPArray.push(m_eLinkedCP2) }
m_eLinkedCP3 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[2]"))
if (m_eLinkedCP3 != null) {CPArray.push(m_eLinkedCP3) }
m_eLinkedCP4 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[3]"))
if (m_eLinkedCP4 != null) {CPArray.push(m_eLinkedCP4) }
m_eLinkedCP5 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[4]"))
if (m_eLinkedCP5 != null) {CPArray.push(m_eLinkedCP5) }
m_eLinkedCP6 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[5]"))
if (m_eLinkedCP6 != null) {CPArray.push(m_eLinkedCP6) }
m_eLinkedCP7 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[6]"))
if (m_eLinkedCP7 != null) {CPArray.push(m_eLinkedCP7) }
m_eLinkedCP8 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[7]"))
if (m_eLinkedCP8 != null) {CPArray.push(m_eLinkedCP8) }

self.PrecacheModel("models/stt/boss_tank_hologram.mdl")

AmountCapped <- 0;

::redplayerarray <- []
m_iRedPlayersAmount <- 0

function SpawnTank()
{
	m_eTank = SpawnEntityFromTable("tank_boss", {
    targetname = "Tank",
	TeamNum = 3,
	speed = m_iSpeed.tofloat(),
	health = CalculateTankHP(),
    target = m_sStartTrack,
	})
	m_eTank.SetOrigin(m_eStartTrack_Ent.GetOrigin())
}

function SpawnTankGlow()
{
	m_eTankGlow = SpawnEntityFromTable("tf_glow", {
    targetname = "Tank_Glow",
	GlowColor = "125 168 196 255",
    target = "Tank",
	})
	//m_eTankGlow.DispatchSpawn()
}
m_eHologramGlow <- null;

function HologramGlow()
{
    m_eTankGlow = SpawnEntityFromTable("tf_glow", {
    targetname = "Hologram_Glow",
    GlowColor = "125 168 196 255",
    target = "Hologram",
    })
}

function Distance3D(v1,v2)
{
	local a = (v2.x-v1.x);
	local b = (v2.y-v1.y);
	local c = (v2.z-v1.z);

	return sqrt((a*a)+(b*b)+(c*c));
}

function clamp( val, minVal, maxVal )
{
	if ( maxVal < minVal )
		return maxVal;
	else if( val < minVal )
		return minVal;
	else if( val > maxVal )
		return maxVal;
	else
		return val;
}

function RemapValClamped( val,  A,  B,  C,  D)
{
	if ( A == B )
		return val >= B ? D : C;
	local cVal = (val - A) / (B - A);
	cVal = clamp( cVal, 0.0, 1.0 );

	return C + (D - C) * cVal;
}

function RemapValClampedRound( val,  A,  B,  C,  D)
{
	if ( A == B )
		return val >= B ? D : C;
	local cVal = (val - A) / (B - A);
	cVal = clamp( cVal, 0.0, 1.0 );

	local unrounded = C + (D - C) * cVal;
	return floor(unrounded / 100) * 100;
}

function CalculateTrackLength()
{
	if(!m_bFirstTrackCheck)
	{
		m_eNextTrack = NetProps.GetPropEntity(m_eStartTrack_Ent, "m_pnext")
		m_iTrackLength = m_iTrackLength + Distance3D(m_eNextTrack.GetOrigin(),m_eStartTrack_Ent.GetOrigin())
		m_bFirstTrackCheck = true
		TrackArray.push(m_eStartTrack_Ent)
		TrackArray.push(m_eNextTrack)
		CalculateTrackLength()
	}
	else if((m_eNextTrack != null) && (m_eNextTrack != m_eEndTrack_Ent))
	{
		m_ePrevTrack = m_eNextTrack
		m_eNextTrack = NetProps.GetPropEntity(m_ePrevTrack, "m_pnext")
		TrackArray.push(m_eNextTrack)
		m_iTrackLength = m_iTrackLength + Distance3D(m_eNextTrack.GetOrigin(),m_ePrevTrack.GetOrigin())
		CalculateTrackLength()
	}
	else
	{
		//printl("end of track!")
		//printl("track length: " + m_iTrackLength + " hu")
	}
}

function CalculateTankHP()
{
  if (m_iRedPlayersAmount < 2)
        return 3000;
    local unrounded = m_iRedPlayersAmount * (m_iTrackLength.tointeger() / 4) + (m_iDefinedHealth / 2)
    return floor(unrounded / 100) * 100;
}
::CalculateBossHP <-function()
{
  if (m_iRedPlayersAmount < 2)
        return 1500;
    local unrounded = m_iRedPlayersAmount * m_iRedPlayersAmount * 55 + (m_iRedPlayersAmount < 6 ? 1500 : 2500)
    return floor(unrounded / 100) * 100;
}

local DeployTime = 999999999;
local AllowDeploy = true;
local AllowBoom = true;
local StopHud = false;

::TickBossBar <- function(player)
{
    local bossBar = Entities.FindByClassname(null, "monster_resource");
    if (bossBar == null)
        bossBar = SpawnEntityFromTable("monster_resource"); //todo this is not how you call this method, but for some reason it doesn't matter anyway

    local hpByte = (player.GetHealth() * 255) / player.GetMaxHealth();
    if (hpByte == 0 && player.GetHealth() > 0)
        hpByte = 1;
    NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", hpByte);
}
m_flTrainDistanceFromStart <- 0.1
trackpassed <- 1 // we assume its at the start
m_flTotalPathDistance <- 0
/*
::TickProgressBar <- function(tank)
{
	if (StopHud)
		return

	local faketankvector = m_eTank.GetOrigin()
	local flDistanceToGoal = Distance3D(TrackArray[trackpassed].GetOrigin(),Vector(faketankvector.x, faketankvector.y, faketankvector.z + 48))
	local things = Distance3D(TrackArray[trackpassed].GetOrigin(),TrackArray[trackpassed - 1].GetOrigin())
	local flDistanceToGoalModded1 = RemapValClamped(flDistanceToGoal, 0, things, 1, 0)
	m_flTotalPathDistance = things * flDistanceToGoalModded1
	printl( RemapValClamped(flDistanceToGoal, 0, things, 1, 0))
	if (TrackArray[trackpassed] && (TrackArray[trackpassed] != m_eEndTrack_Ent))
	{
		if (flDistanceToGoal < 8.25)
		{
			m_flTrainDistanceFromStart = m_flTrainDistanceFromStart + Distance3D(TrackArray[trackpassed].GetOrigin(),TrackArray[trackpassed - 1].GetOrigin())
			trackpassed++
		}
	}
	local progressfortank = RemapValClamped((m_flTotalPathDistance + m_flTrainDistanceFromStart), 0, m_iTrackLength, 0.0, 1.0)

	NetProps.SetPropFloat(team_train_watcher, "m_flTotalProgress", progressfortank)
}
*/

function TankThink()
{
	if(m_eTank != null)
	{
		TickBossBar(m_eTank)
		local faketankvector = m_eTank.GetOrigin()
		if(Entities.FindByNameNearest(m_sEndTrack, Vector(faketankvector.x, faketankvector.y, faketankvector.z + 48), 4.0))
		{
			if(AllowDeploy)// since this a constant think it might trigger the deploy again, we only need one!
			{
				AllowDeploy = false
				StopHud = true
				DeployTime = 8 + Time()
			}

			if(Time() > DeployTime)
			{
				if(AllowBoom)
				{
					AllowBoom = false
					OnDeployBomb()
				}
			}
		}
	}
	foreach (currencypack in money_table)
    {
        local ent = null
        while ((ent = Entities.FindByClassname(ent, currencypack[0])) != null)
        {
            ent.Destroy()
        }
    }
	EntFireByHandle(self, "RunScriptCode", "TankThink()", m_flTankThinkTime, null, null); // call self to make a fake think!
}

::TankPostSpawn <- function()
//function OnPostSpawn()
{
	CalculateTrackLength()
	TankThink()
	m_eFakeTankMain = SpawnEntityFromTable("prop_dynamic", {
   		model = "models/stt/boss_tank_hologram.mdl",
		targetname = "Hologram",
		solid = 6,
		renderfx = 15,
		rendercolor = "255 255 255",
		renderamt = 126,
		disableshadows = 1,
	})
	local faketankvector = m_eStartTrack_Ent.GetOrigin()
	m_eFakeTankMain.SetOrigin(Vector(faketankvector.x, faketankvector.y, faketankvector.z - 48))
	m_eFakeTankMain.SetAbsAngles(VectorAngles(m_eStartTrack_Ent.GetOrigin(),NetProps.GetPropEntity(m_eStartTrack_Ent, "m_pnext").GetOrigin()))
	HologramGlow()
}

function OnDeployBomb()
{
	EntFire("boss_deploy_relay", "trigger", "", 0.0);
	EntFire("tank", "destroyifatcapturepoint", "true", 0.1);
	local bossBar = Entities.FindByClassname(null, "monster_resource");
    NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", 0);
	m_eTank = null;
}

BombFlag <- Entities.FindByClassname(null, "item_teamflag")
function OnKilled()
{
	if (CPArray[AmountCapped].GetClassname() == "path_track")
	{
		printl(CPArray[AmountCapped])
		local pathtrackvector = CPArray[AmountCapped].GetOrigin()
		BombFlag.SetOrigin(Vector(pathtrackvector.x, pathtrackvector.y,pathtrackvector.z - 48 ))
	}
	else
	{
		printl(CPArray[AmountCapped])
		BombFlag.SetOrigin(CPArray[AmountCapped].GetOrigin())
	}
	EntFire("boss_dead_relay", "trigger", "", 0.0);

}

ClearGameEventCallbacks();

function OnGameEvent_mvm_tank_destroyed_by_players(params)
{
	//DeathTankMoney(params)
	m_eTank = null;
	local bossBar = Entities.FindByClassname(null, "monster_resource");
    NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", 0);
	EntFireByHandle(m_eTrain, "kill", "", 0.0, null, null)
	if(AllowBoom)
	{
		OnKilled()
	}
}
::captured <- function()
{
	printl("aaa")
	AmountCapped++
}
function OnGameEvent_teamplay_setup_finished(params)
{
	m_eFakeTankMain.Kill()
	m_iRedPlayersAmount = redplayerarray.len()
	SpawnTank()
	SpawnTankGlow()
	EntFireByHandle(m_eTrain, "StartForward", "", 0.0, null, null)
	/*
	local trackamount = TrackArray.len() - 1
	for (local i = 0; i <= trackamount ; i++)
	{
		printl(TrackArray[i])
	}
	local cpamount = CPArray.len() - 1
	for (local i = 0; i <= cpamount ; i++)
	{
		printl(CPArray[i])
	}
	*/
}

/*
function OnScriptHook_OnTakeDamage(params)
{
		local MaxDamageTypes = 30
		for (local i = 1; i <= MaxDamageTypes ; i++)
		{
			local damagetype = 1 << i
			if((params.damage_type & damagetype) == damagetype)
			{
				print(damagetype + ", ")
			}
		}
	if (params.const_entity.GetClassname() == "tank_boss")
    {
		if(params.const_entity.GetHealth() - params.damage <= 0)
		{
			m_eTank = null;
			local bossBar = Entities.FindByClassname(null, "monster_resource");
			bossBar.Kill()
		}
	}
}
*/
::TankPlayerSpawn <- function(params)
//function OnGameEvent_player_spawn(params)
{
    if("userid" in params)
    {
		local player = GetPlayerFromUserID(params.userid)
		if(player.GetTeam() == 2)
		{
			local index = redplayerarray.find(player);
			if (index != null)
			{

			}
			else
			{
				redplayerarray.push(player)
			}
		}
		if(player.GetTeam() == 3)
		{
            local index = redplayerarray.find(player);
			if (index != null)
			{
				redplayerarray.remove(index)
			}
		}
	}
}

function OnGameEvent_player_disconnect(params)
{
    if("userid" in params)
    {
		local player = GetPlayerFromUserID(params.userid)
		if(player.GetTeam() == 2)
		{
			local index = redplayerarray.find(player);
			if (index != null)
			{
				redplayerarray.remove(index)
			}
		}
	}
}
__CollectGameEventCallbacks(this)